package laboratoire4;

public class MiniMax {
    private static final int MAX_DEPTH = 4;

    public static int miniMax(GameTree tree) {
        return miniMax(tree.getRoot(), Player.MAX, 0);
    }

    private static int miniMax(GameTree.Node node, Player player, int depth) {
        if (depth == MAX_DEPTH) {
            return evaluate(node);
        }

        return player == Player.MAX ?
                max(node, depth) :
                min(node, depth);
    }

    private static int max(GameTree.Node node, int depth) {
        int maxScore = Integer.MIN_VALUE;

        for (GameTree.Node child : node.getChilds()) {
            int score = miniMax(child, Player.MIN, depth + 1);
            if (score > maxScore) {
                maxScore = score;
            }
        }

        return maxScore;
    }

    private static int min(GameTree.Node node, int depth) {
        int minScore = Integer.MAX_VALUE;

        for (GameTree.Node child : node.getChilds()) {
            int score = miniMax(child, Player.MIN, depth + 1);
            if (score < minScore) {
                minScore = score;
            }
        }

        return minScore;
    }

    private static int evaluate(GameTree.Node node) {

        return 0;
    }
}
